
#ifndef _ABSTRACT_DEQUE_H_
#define _ABSTRACT_DEQUE_H_

template <typename T>
class AbstractDeque
{
public:

  // return true is the queue is empty
  virtual bool isEmpty() = 0;

  // enqueue (add) newEntry into the queue back
  // throw exception if not possible
  virtual void enqueue_back(const T& item) = 0;

  // enqueue (add) newEntry into the queue front
  // throw exception if not possible
  virtual void enqueue_front(const T& item) = 0;
  
  // dequeue (remove) newEntry from the queue front
  // throw exception if not possible
  virtual void dequeue_front() = 0;

  // dequeue (remove) newEntry from the queue back
  // throw exception if not possible
  virtual void dequeue_back() = 0;

  // return a copy of the item at the front of the queue
  // throw exception if not possible
  virtual T peek_front() = 0;

  // return a copy of the item at the back of the queue
  // throw exception if not possible
  virtual T peek_back() = 0;
};

#endif // _ABSTRACT_DEQUE_H_
